;************************************************************************
;*
;*	Filename : Control.x65
;*	Version  : 1.0
;*	(c) 1993 Nintendo of America Inc.
;*	Translation : Shoya Tanaka
;*
;************************************************************************
;
;
;	Controller service
;
		LIB	DEFINE\65816.DEF
		LIB	DEFINE\SFC.DEF
		LIB	DEFINE\PERSP.DEF
;
		PUBLIC	zoom,opposite
		PUBLIC	situation_X,situation_Y,situation_Z
		PUBLIC	situation_Q,situation_P,situation_R
		PUBLIC	Control_process
CODE		GROUP
		EXTERN	Fork_process,Wait_field
BANK3		GROUP
		EXTERN	Screen_logo
PERSP		GROUP
		EXTERN	PERSP_bank,PERSP_data,PERSP_status
;
PAGE0		GROUP
zoom		DS	2
opposite	DS	1
situation_X	DS	2	;for east
situation_Y	DS	2	;for south
situation_Z	DS	2	;for ground
situation_Q	DS	2	;yawing
situation_P	DS	2	;pitching
situation_R	DS	2	;rolling
;--------------------------------------------------------------------------
DATA		GROUP
		DS	26
control_process	DS	6
;
BANK0		GROUP
pitch_data	DW	0,+256,-256,0
velocity_data	DW	0,+16,-32,+48
;
CODE		GROUP
		mwxw
Control_process	LDX	#control_process
		JSL	~Fork_process
;	initialize each parameter (start)		;
control_preset	LDA	#$0100				;w
		STA	.zoom				;w
		LDA	#$C0				;w(b)
		STA	.opposite			;w(b)
		LDA	#$0200				;w
		STA	.situation_X			;w
		STA	.situation_Y			;w
		LDA	#$FF00				;w
		STA	.situation_Z			;w
		LDA	#$8000				;w
		STZ	.situation_Q			;w
		STA	.situation_P			;w
		STZ	.situation_R			;w
;
control_loop	JSL	~Wait_field
		LDA	!Button_1			;w
		BIT	#button_start*256		;w
		BNE	control_preset
;
;	control zoom (L R)
;
		LDA	.zoom				;w
		mB	fC
		LDA	!Button_1+0			;b
		AND	#%00110000 ;button_L+button_R	;b
		BEQ	zoom_skip
		EOR	#%00110000 ;button_L+button_R	;b
		BEQ	zoom_skip
		SBC	#%00100000 ;button_L		;b
		mW
		BEQ	zoom_tele
zoom_wide	EOR	#%1111111100001111		;w
zoom_tele	XBA
		ADC	.zoom				;w
		BEQ	zoom_skip
		STA	.zoom				;w
zoom_skip
;
;	control yielding (<- ->)
;
		mWxW
		LDA	!Button_1			;w
		AND	#%0000001100000000		;w
		XBA
		ASL	A
		TAX
		LDA	!pitch_data,X			;w
		BIT	.opposite-1			;w
		BVC	_skip
		EOR	#%1111111111111111		;w
		INC	A
_skip		ADC	.situation_Q			;w
		STA	.situation_Q			;w
;
;	control pitching (up down)
;
		LDA	!Button_1			;w
		AND	#%0000110000000000		;w
		XBA
		LSR	A
		TAX
		LDA	!pitch_data,X			;w
		ADC	.situation_P			;w
		STA	.situation_P			;w
;
;	control moving (A B X Y)
;
forward		mBxB
		LDA	!Button_1+0			;b
		ASL	A
		AND	#%10000000			;b
		ADC	#%00111111			;b
		ORA	!Button_1+1			;b
		ROL	A
		ROL	A
		ROL	A
		ROL	A
		AND	#%00000110			;b
		TAX
		PEA	#PERSP_bank			;>>
		PLB					;<
		LDA	#persp_attitude0		;b
		STA	!PERSP_data			;b
		mW	fC
		LDA	#$7FFF				;w
		STA	!PERSP_data			;w
		LDA	.situation_Q			;w
		STA	!PERSP_data			;w 
		LDA	#$C000				;w
		ADC	.situation_P			;w
		STA	!PERSP_data			;w 
		STZ	!PERSP_data			;w 
		mB	fC
forward_wait	BIT	!PERSP_status			;b
		BPL	forward_wait
		LDA	#persp_subject0			;b
		STA	!PERSP_data			;b
		mWxW
		LDA	~velocity_data,X		;w
		STA	!PERSP_data			;w e
		STZ	!PERSP_data			;w k
		STZ	!PERSP_data			;w t
		LDA	.situation_Y			;w
		SBC	!PERSP_data			;w x
		STA	.situation_Y			;w
		SEC
		LDA	.situation_X			;w
		SBC	!PERSP_data			;w w
		STA	.situation_X			;w
		CLC
		LDA	!PERSP_data			;w y
		PLB					;<
		ADC	.situation_Z			;w
		BMI	adjust
		STA	.situation_Z			;w
		JMP	control_loop
;
;	change parameter during under ground
;
adjust		EOR	#%1111111111111111		;w
		INC	A
		STA	.situation_Z			;w
		SEC
		LDA	#$0400				;w
		SBC	.situation_Y			;w
		STA	.situation_Y			;w
		LDA	.situation_P			;w
		EOR	#%1000000000000000		;w
		STA	.situation_P			;w
		SEC
		LDA	#$0000				;w
		SBC	.situation_Q			;w
		STA	.situation_Q			;w
		mB
		LDA	#%11000000			;b
		EOR	.opposite			;b
		STA	.opposite			;b
		ASL	A
		JSL	~Screen_logo
		mW
		JMP	control_loop
;
		END
