;************************************************************************
;*
;*	Filename : Object.x65
;*	Version  : 1.0
;*	(c) 1993 Nintendo of America Inc.
;*	Translation : Shoya Tanaka
;*
;************************************************************************
;
;
;	control sprite by object thought process
;
		LIB	DEFINE\65816.DEF
		LIB	DEFINE\LIST.DEF
		LIB	DEFINE\PERSP.DEF
;
		PUBLIC	Initiate_object,Appeal_object,Sort_object
		PUBLIC	Born_object,Kill_object
		PUBLIC	Null,Pose,Size,Project
		PUBLIC	object_code
		PUBLIC	object_M,object_X,object_Y,object_Z,object_C
;
PAGE0		GROUP
		EXTERN	sprite_pointer,opposite
PERSP		GROUP
		EXTERN	PERSP_bank,PERSP_data,PERSP_status
;
PAGE0		GROUP
object_pointer	DS	2		;pointer for object variable
sprite_H	DS	2		;virtual variables
sprite_V	DS	2
sprite_C	DS	2
sprite_A	DS	2
sprite_S	DS	2
p_offsetH	DS	2		;work area
p_offsetV	DS	2
p_size		DS	2
p_charactor	DS	2
temporary	DS	2
;
DATA		GROUP
object_root	DS	6		;root object variable
object_backward	EQU	0		;object variable structure
object_forward	EQU	2
object_code	EQU	4
object_M	EQU	6
object_X	EQU	8
object_Y	EQU	10
object_Z	EQU	12
object_C	EQU	14
;
BANK0		GROUP
Root		PLX			;root procedure
		RTL
;
root_object	DW	Root		;root object
object_command	EQU	0		;object code
;
CODE		GROUP
;
;	initial object control system
;
		xw
Initiate_object	LDY	#object_root			;w
		TYX
		STY	.object_backward,X		;w
		STY	.object_forward,X		;w
		LDY	#root_object			;w
		STY	.object_code,X			;w
		RTL
;
;	create object
;
		mwxw
Born_object	LDY	#object_root		;X:object structure
		insert_list
		RTL
;
;	delete object
;
		mwxw
Kill_object	delete_list			;X:object structure
		RTL
;
;	sort object
;	bubble sort object order sequentally according to object variable
;
		mwxw
Sort_object	LDX	!object_root+object_forward	;w
_loop		TXY
		LDX	.object_forward,Y		;w
		CPX	#object_root			;w
		BEQ	_exit
		LDA	!object_M,Y			;w
		CMP	.object_M,X			;w
		BCS	_loop
		PHX					;>>
		LDA	.object_forward,X		;w
		TAX
		STY	.object_backward,X		;w
		STX	.object_forward,Y		;w
		PLX					;<<
		LDA	!object_backward,Y		;w
		STX	.object_backward,Y		;w
		STY	.object_forward,X		;w
		TAY
		STY	.object_backward,X		;w
		STX	.object_forward,Y		;w
_exit		RTL
;
BANK0		GROUP
;
;	move object
;
Move_object	RTL
;
Appeal_object	LDY	!object_root+object_forward	;w
_loop		STY	.object_pointer			;w
		LDX	.object_code,Y			;w
		JSRX	object_command
		LDX	.object_pointer			;w
		LDY	.object_forward,X		;w
		BRA	_loop
		RTS
;
;	request object
;
		xw
Request_object	LDY	!object_root+object_forward	;w
_loop		STY	.object_pointer			;w
		LDX	.object_code,Y			;w
		JSRX	object_command
		LDX	.object_pointer			;w
		LDY	.object_forward,X		;w
		BRA	_loop
;
;	invalid procedure
;
Null		RTS
;
;	sprite composition procedure
;offsetH	DW	offsetH1,offsetH2,..,offsetHN
;offsetV	DW	offsetV1,offsetV2,..,offsetVN
;size		DW	size1,size2,..,sizeN
;object		DW	Pose,2N-2,offsetH,offsetV,size
;		DW	charactor1,charactor2,..,charactorN
s_count		EQU	2
s_offsetH	EQU	4
s_offsetV	EQU	6
s_size		EQU	8
s_charactor	EQU	10
		mwxw
Pose		LDY	.s_count,X			;w
		LDA	.s_offsetH,X			;w
		STA	.p_offsetH			;w
		LDA	.s_offsetV,X			;w
		STA	.p_offsetV			;w
		LDA	.s_size,X			;w
		STA	.p_size				;w
		CLC
		TXA
		ADC	#s_charactor			;w
		STA	.p_charactor			;w
		LDX	.sprite_pointer			;w
_loop		CLC
		LDA	.sprite_H
		ADC	(<p_offsetH),Y			;w
		CMP	#$0100				;w
		BCC	_storeH
		CMP	#$FFC0				;w
		BCC	_range_out
_storeH		mB
		STA	.0,X				;b
		LDA	(<p_size),Y			;b
		ROL	A
		STA	!512+32,X			;b
		mW	fC
		LDA	.sprite_V			;w
		ADC	(<p_offsetV),Y			;w
		CMP	#$00E0				;w
		BCC	_storeV
		CMP	#$FFE0				;w
		BCC	_range_out
_storeV		STA	.1,X				;w(b)
		LDA	(<p_charactor),Y		;w
		EOR	.sprite_C			;w
		STA	.2,X				;w
		INX
		INX
		INX
		INX
_range_out	DEY
		DEY
		BPL	_loop
		STX	.sprite_pointer			;w
		RTS
;
;	sizing procedure
;reference	DW	levelN,..,level1,level0,0
;object		DW	Size,reference,objectN,..,object1,object0
s_reference	EQU	2
s_object	EQU	4
		mwxw
Size		STX	.temporary			;w
		LDY	.s_reference,X			;w
		LDA	.sprite_S			;w
_scan		CMP	!0,Y				;w
		INY
		INY
		BCC	_scan
		TYA
		SBC	.s_reference,X			;w
;		SEC
		ADC	.temporary			;w
		TAY
		LDX	.s_object-2-1,Y			;w
		JMPX	0
;
;	projection and choice of color procedure
;object		DW	Project,procedure,...
		mwxw
Project		TXY
		LDX	.object_pointer			;w
		PEA	#PERSP_bank			;>>
		PLB					;<
		mB
		LDA	#persp_project			;b
		STA	!PERSP_data			;b command
		BIT	.opposite			;b
		mW
		LDA	.object_X,X			;w
		STA	!PERSP_data			;w
		BVS	_opposite
		LDA	.object_Y,X			;w
		STA	!PERSP_data			;w
		LDA	.object_Z,X			;w
		STA	!PERSP_data			;w
		LDA	.object_C,X			;w
		BRA	_common
_opposite	SEC
		LDA	#$0400				;w
		SBC	.object_Y,X			;w
		STA	!PERSP_data			;w
		SEC
		LDA	#$0000				;w
		SBC	.object_Z,X			;w
		STA	!PERSP_data			;w
		LDA	.object_C,X			;w
		EOR	#$2000				;w
_common		STA	.sprite_C			;w choice of color
		CLC
		LDA	#$0080				;w
_wait		BIT	!PERSP_status			;w(b)
		BPL	_wait
		ADC	!PERSP_data			;w
		STA	.sprite_H			;w
		CLC
		LDA	#$0070				;w
		ADC	!PERSP_data			;w
		STA	.sprite_V			;w
		LDA	!PERSP_data			;w
		BMI	_range_out
		PLB					;<
		STA	.object_M,X			;w
		STA	.sprite_S			;w
		TYX
		INX
		INX
		JMPX	0
_range_out	PLB					;<
		STZ	.object_M,X			;w
		RTS
;
		END
;
		control	sprite by object thought process

Object which we say here means that the data and procedure of sprite are
collected together. Each object is equal to each character.

You can create, delete and operate a circumstances for object from outside.
System call Move_object, Request_object and Sort_object and execute all alive
object. Therefore, if object which created once is not deleted, it move and
request as its pleases. We programmed object like the above.

Each object consists of object variable in RAM area and object definition in
ROM area that is directed by command in RAM area. Object definition is written
by object language. The content written by object language is how to request
and moving style and influence from circumstances e.t.c. How to request of 
object is controlled by Dynamic Sprite Manager.
;
		Outline of object language

Assemble language is listed instruction, but this language regards memory
pointer which there is procedure as instructions. This (memory pointer)
is 2 bytes address in bank 0. Thinking that procedure is defined is better
than thinking that procedure is written.

		Ready-made procedure	

1. Puse definitizer

Characters and things in game is expressed by combination of several kind
of pose. This pose is expressed by gathering of several sprite. In this 
procedure, gathering of several sprite(=pose) is defined. The position of pose
is given by virtcal variable Sprite_H and Sprite_V , and the attribute data of
pose that is palette e.t.c. is given by Sprite_C.

[form]
object		DW	_Pose,count,hofs,vofs,size,char1,char2,..,charN
hofs		DW	hofs1,hofs2,..,hofsN
vofs		DW	vofs1,vofs2,..,vofsN
size		DW	size1,size2,..,sizeN

	object		defined pose name 
	_Pose		pose code
	count		the number of sprite in the pose
	hofs		horizontal offset list of sprite
	 hofs1'N	horizontal offset of each sprite
	vofs		vertical offset list of sprite
	 vofs1'N	vertical offset of each sprite
	size		size list of each sprite
	 size1'N	size of each sprite (0:small 1:big)
	char1'N		Character No. and standard attribute of sprite


2. Size definitizer

The pose of one thing is changed varivously by the sutuation. This procedure
is used, when the size is changed by distance parameter. For example, if 
virtual variable Sprite_M is between one valure and one valure, then one pose
is defined.

[form]
object		DW	_Size,size,pose1,pose2,..,poseN
size		DW	sizeN,sizeN-1,...,size1,0

	object		defined object name
	_Group		size procedure
	size		size threshold list
	 size1'N	size threshold
	pose1'N		pose name correspond each size


3. Project prefix

In order to display "object" which coordinate is decided by 3-D information,
it must be changed to screen coordinate. In this procedure, the coordinate is 
changed according to object variable Object_X, Object_Y and Object_Z. This 
procedure also put out object variable Object_M and virtual variable Sprite_H,
Sprite_V and Sprite_M. Supposing that view point parameter e.t.c. is put in
DSP1 already, only positive Z-axis value is permitted in the DSP1, so, when 
Z-axis value is negative, it will be revised by using frag variable "opposite". 
The priority against back ground is changed by the above information and the
color information is given by object variable Object_C, then virtual variable
is put out. This procedure should be located before your aim procedure.

[form]
object		DW	_Project,procedure,...

	object		defined object name	;
	_Project	project procedure	;
	procedure	procedure for changing	;


4. Null definitazer

Definition is renounced. this section is used when sprite is not displayed.

[form]
object		DW	_Null

	object		defined object name
	_Null		return procedure

