;************************************************************************
;*
;*	Filename : PERSP.X65
;*	Version  : 1.0
;*	(c) 1993 Nintendo of America Inc.
;*	Translation : Shoya Tanaka
;*
;************************************************************************
;
;
;	Perspective Generation
;
		LIB	DEFINE\65816.DEF
		LIB	DEFINE\SFC.DEF
		LIB	DEFINE\MACRO.DEF
		LIB	DEFINE\PERSP.DEF
;
		PUBLIC	Param_process,Persp_process
PAGE0		GROUP
		EXTERN	zoom
		EXTERN	situation_X,situation_Y,situation_Z
		EXTERN	situation_Q,situation_P
		EXTERN	nmi_control
CODE		GROUP
		EXTERN	Fork_process,Wait_field
PERSP		GROUP
		EXTERN	PERSP_bank,PERSP_data,PERSP_status
;
;	interrupt horizon
;
;	change screen at horizon
;
PAGE0		GROUP
horizon_path	DS	2
;
COMMON		GROUP
		ORG	$FFEE
		DW	IRQ
;
BANK0		GROUP
IRQ		PHB					;>
		PHK					;>
		PLB					;>
		mB
		PHA					;>
		LDA	.horizon_path+1			;b
		STA	!Video_path+0			;b
		LDA	!Timer_status			;b
		PLA					;<
		PLB					;<
		RTI
;
;	Parameter process
;
;	All next field parameter are gathered, then this process is send to 
;	DSP1.
;
PAGE0		GROUP
center_raster	DS	2
center_X	DS	2
center_Y	DS	2
horizon		DS	2
;
DATA		GROUP
		DS	26			;block of process control
param_process	DS	6
;
CODE		GROUP
		mwxw
Param_process	LDX	#param_process			;w
		JSL	~Fork_process
;
;	set parameter to DSP1
param_loop	mB
		PEA	#PERSP_bank			;>>
		PLB					;<
		LDA	#persp_parameter		;b
		STA	!PERSP_data			;b command
		LDX	.situation_X			;w
		STX	!PERSP_data			;w F X
		LDX	.situation_Y			;w
		STX	!PERSP_data			;w F Y
		LDX	.situation_Z			;w
		STX	!PERSP_data			;w F Z
		LDX	#0
		STX	!PERSP_data			;w L f e
		LDX	.zoom				;w
		STX	!PERSP_data			;w L e s
		LDX	.situation_Q			;w
		STX	!PERSP_data			;w A a s
		LDX	.situation_P			;w
		STX	!PERSP_data			;w A z s
parameter_wait	BIT	!PERSP_status			;b
		BPL	parameter_wait
		mWxW	fC
		LDA	!PERSP_data			;w V o f
		ADC	#$0070				;w
		STA	.center_raster			;w
		CLC
		ADC	!PERSP_data			;w V v a
		LDX	!PERSP_data			;w C x
		STX	.center_X			;w
		LDY	!PERSP_data			;w C y
		STY	.center_Y			;w
		PLB					;<
;
;	make horizon data
;
		TAY
		BPL	horizon_upper
		LDY	#$0000				;w
horizon_upper	CPY	#$00E0				;w
		BCC	horizon_under
		LDY	#$00E0				;w
horizon_under	LDA	#%0001000000010001		;w
		CPY	#$0070				;w
		LDX	.situation_P			;w
		BPL	horizon_plus
horizon_minus	BCC	horizon_store
		CPX	#$C000				;w
		BCS	horizon_store
		LDY	#$0000				;w
		BRA	horizon_store
horizon_plus	XBA
		BCS	horizon_store
		CPX	#$4000				;w
		BCC	horizon_store
		LDY	#$00E0				;w
horizon_store	STA	.horizon_path			;w
		STY	.horizon			;w
;
		JSL	~Wait_field
		JMP	param_loop
;
;	perspective process
;
;	initial structure which is related to perspective
;	Current field perspective data is sent to PPU just after vertical
;	synchronization.
;
PAGE0		GROUP
temporary	DS	2
;
DATA		GROUP
		DS	26			;block of porcess control
persp_process	DS	6
perspective_A	DS	896			;raster DMA buffer 
perspective_C	DS	896
;
BANK0		GROUP
guide_table_7	DB	%10000000+111	;raster DMA guide table
		DW	perspective_A+4
		DB	%10000000+112
		DW	perspective_A+448
		DB	0
guide_table_6	DB	%10000000+111
		DW	perspective_C+4
		DB	%10000000+112
		DW	perspective_C+448
		DB	0
;
CODE		GROUP
		mwxw
Persp_process	LDX	#persp_process			;w
		JSL	~Fork_process
;
		mB				;initial perspective DMA
		LDA	#dma_ST+dma_I+dma_INC+dma_2W	;b
		STA	!DMA_7+DMA_control		;b
		STA	!DMA_6+DMA_control		;b
		LDA	#Rotation_A&$FF			;b
		STA	!DMA_7+DMA_register		;b
		LDA	#Rotation_C&$FF			;b
		STA	!DMA_6+DMA_register		;b
		LDX	#guide_table_7			;w
		STX	!DMA_7+DMA_address+0		;w
		LDX	#guide_table_6			;w
		STX	!DMA_6+DMA_address+0		;w
		STZ	!DMA_7+DMA_address+2		;b
		STZ	!DMA_6+DMA_address+2		;b
		STZ	!DMA_7+DMA_bank			;b
		STZ	!DMA_6+DMA_bank			;b
		LDA	#dma_7+dma_6			;b
		STA	!DMA_raster			;b
;
		mW
		JSL	~Wait_field
;
		mB				;initial horizon interruption
		LDX	#240				;w
		STX	!Timer_H			;w
		LDA	#timer_H+timer_V		;b
		ORA	.nmi_control			;b
		STA	.nmi_control			;b
		STA	!NMI_control			;b
		set_brightness 15		; turn on display
		mW
;
;	Coordinate data (X,Y,H,V) are set to PPU.	;
;
persp_loop	LDA	.center_X			;w
		mB	fC
		STA	!Rotation_X			;b
		SBC	#$80				;b
		XBA
		STA	!Rotation_X			;b
		SBC	#$00				;b
		XBA
		storeLH	Scroll_H
		SEC
		LDA	.center_Y+0			;b
		STA	!Rotation_Y			;b
		SBC	.center_raster+0		;b
		XBA
		LDA	.center_Y+1			;b
		STA	!Rotation_Y			;b
		SBC	.center_raster+1		;b
		XBA
		storeLH	Scroll_V
;
;	Set the timing to interrupt horizon and control screen 
;
		LDX	.horizon			;w
		STX	!Timer_V			;w
		LDA	.horizon_path+0			;b
		STA	!Video_path+0			;b
;
;	Translate raster data (A,B,C,D) to DMA buffer
;	The data is translated to PPU from DMA buffer by DMA
;
		PEA	#PERSP_bank			;>>
		PLB					;<
		LDA	#persp_raster			;b
		STA	!PERSP_data			;b command
		mWxW	fC+fI
		LDA	#1				;w
		SBC	.center_raster			;w
		STA	!PERSP_data			;w V s
		LDX	#perspective_A			;w
raster_loop	STX	.temporary			;w
		mB
raster_wait1	BIT	!PERSP_status			;b
		BPL	raster_wait1
		mW
		LDY	!PERSP_data			;w A i
		LDX	!PERSP_data			;w B i
		PHX					;>>
		LDA	!PERSP_data			;w C i
		LDX	!PERSP_data			;w D i
		PHX					;>>
		LDX	.temporary			;w
		STA	!896,X				;w
		PLA					;<<
		STA	!898,X				;w
		STY	.0,X				;w
		PLY					;<<
		STY	.2,X				;w
		INX
		INX
		INX
		INX
		CPX	#perspective_C			;w
		BNE	raster_loop
		EOR	#$8000				;w
raster_wait2	BIT	!PERSP_status			;b
		BPL	raster_wait2
		LDX	!PERSP_data			;w A i
		LDX	!PERSP_data			;w B i
		LDX	!PERSP_data			;w C i
		STA	!PERSP_data			;w D i
		PLB					;<
;
		JSL	~Wait_field
		JMP	persp_loop
;
		END
