;************************************************************************
;*
;*	Filename : sfvim.x65
;*	Version  : 1.0
;*	(c) 1993 Nintendo of America Inc.
;*	Translation : Shoya Tanaka
;*
;************************************************************************
;
;
;	Super NES NMI control system
;
		LIB	DEFINE\65816.DEF
;
execute_link	EQU	0
execute_vector	EQU	2
;
PAGE0		GROUP
execute_top	DS	2
execute_bottom	DS	2
;
CODE		GROUP
		PUBLIC	Initiate_NMI
		mw
Initiate_NMI	STZ	.execute_top
		STZ	.execute_bottom
		RTL
;
		PUBLIC	Reserve_NMI
		mbxw
Reserve_NMI	LDY	.execute_bottom
		STX	.execute_bottom
		BNE	reserve_skip
		STX	.execute_top
		TXY
reserve_skip	STX	.execute_link,Y
		STZ	.execute_link+0,X
		STZ	.execute_link+1,X
		PLY				;<<
		STY	.execute_vector+0,X	;w
		PLA				;<
		STA	.execute_vector+2,X	;b
		RTL
;
		PUBLIC	Execute_NMI
		mbxw
execute_loop	LDY	.execute_link,X
		STY	.execute_top
		JSL	execute_sub
Execute_NMI	LDX	.execute_top
		BNE	execute_loop
		STX	.execute_bottom
		RTL
execute_sub	LDA	.execute_vector+2,X	;b
		PHA				;>
		LDY	.execute_vector+0,X	;w
		PHY				;>>
		RTL				;<<<
;
		END

	Super NES NMI control system (Ver 1.0)

0. Initialize system

This system is initialized by Initiate_NMI.

[example]
CODE		GROUP
		 |
		REP	#%00100000
		JSL	Initiate_NMI
		 |


1. NMI disposal reservation

The programs which are executed during NMI are changed to subroutine, and
the subroutine is reserved by Reserve_NMI, and the subroutine will be executed
during next NMI.

NMI disposal subroutine is started in the following condition DBR=0,DP=0,M flag=1
X flag=0). It is nesessarry to end the NMI disposal subroutine in the same 
condition.

Process disposal is able to do the same disposal like NMI disposal, but process
disposal causes overhead of process change during NMI blanking, so we just
provide faster process. 

[example]
DATA		GROUP
sample_execute	DS	5	;reserved execution structure

CODE		GROUP
		 |
		JSL	Execute_sample
		 |

		 |
Execute_sample	REP	#%00010000
		SEP	#%00100000
		LDX	#sample_execute
		JSL	Reserve_NMI
		 |
		NMI disposal program
		 |
		RTL


2. Execute NMI disposal

Execute_NMI is the program which execute subroutin which is reserved by 
Reserve_NMI, and Execute_NMI is located in NMI disposal. If reserved several
subroutine exit, they will be executed by turn that is same as reserved turn.

[example]
BANK0		GROUP
NMI		 |
		REP	#%00010000
		SEP	#%00100000
		JSL	Execute_NMI
		 |
		RTI

COMMON		GROUP
		ORG	$00FFEA
		DW	NMI


3. NMI disposal control structure

Reservation program form the list by reserved trun, and Execute_top designate
the top of the list and Execute_bottom designate the end of the list.



4. Caution

Reservation execution structure is located in Bank 0 and is 5 bytes.


5. Requirement and condition when NMI supervisor is used.

Show requirement when each supervisor is called and returned condition.



About above figure, - means position, up < means preservation, R means
reservation execution structure, * means to return one nest upper subroutine.
